'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _deepmerge = require('deepmerge');

var _deepmerge2 = _interopRequireDefault(_deepmerge);

var _ = require('../.');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var EventDiory = function EventDiory(_ref) {
  var _ref$diorys = _ref.diorys,
      diorys = _ref$diorys === undefined ? {} : _ref$diorys,
      diory = _objectWithoutProperties(_ref, ['diorys']);

  return _react2.default.createElement(
    _.Diory,
    withStyle(diory, 'diory'),
    _react2.default.createElement(
      _.DioryGrid,
      withStyle(getDiorysStyles(diory), 'diorys'),
      _react2.default.createElement(_.Diory, withStyle(diorys.startDate, 'date')),
      _react2.default.createElement(_.Diory, withStyle(diorys.endDate, 'date')),
      _react2.default.createElement(_.Diory, withStyle(diorys.description, 'description')),
      _react2.default.createElement(_.DioryGrid, withStyle(diorys.images, 'images')),
      _react2.default.createElement(_.Diory, withStyle(diorys.places, 'places')),
      _react2.default.createElement(_.DioryGrid, withStyle(diorys.links, 'links')),
      _react2.default.createElement(_.DioryGrid, withStyle(diorys.persons, 'persons'))
    )
  );
};

var withStyle = function withStyle(diory, key) {
  return (0, _deepmerge2.default)({ style: defaultStyles[key] || {} }, diory || {});
};
var getDiorysStyles = function getDiorysStyles(_ref2) {
  var _ref2$style = _ref2.style,
      style = _ref2$style === undefined ? {} : _ref2$style;
  return { style: style.diorys };
};

var defaultStyles = {
  diory: {
    height: '100%',
    overflow: 'hidden',
    text: { fontSize: '4em', fontFamily: 'sans-serif', color: 'white', textAlign: 'center' },
    image: { opacity: '0.9', filter: 'blur(10px)', transform: 'scale(1.05)' }
  },
  diorys: {
    display: 'flex'
  },
  date: {
    text: {
      fontFamily: 'arial',
      fontSize: '1.5em',
      fontWeight: 'bold',
      color: 'white'
    }
  },
  description: {
    text: {
      fontFamily: 'arial',
      fontSize: '1em',
      color: 'white'
    }
  },
  images: {
    display: 'flex',
    justifyContent: 'center',
    width: 'initial',
    height: 'initial'
  },
  places: {
    text: {
      fontFamily: 'arial',
      fontSize: '2em',
      fontWeight: 'bold',
      color: 'white'
    }
  },
  links: {
    display: 'flex',
    height: 'initial',
    diorys: {
      backgroundColor: 'green',
      text: {
        fontFamily: 'arial',
        fontSize: '1em',
        fontWeight: 'bold',
        color: 'white'
      }
    }
  },
  persons: {
    display: 'flex',
    justifyContent: 'center',
    width: 'initial',
    height: 'initial',
    diorys: {
      margin: '3em',
      width: '5em',
      height: '5em',
      flex: '',
      text: {
        top: '100%',
        fontFamily: 'arial',
        fontWeight: 'bold',
        color: 'white'
      },
      image: {
        borderRadius: '50%'
      }
    }
  }
};

EventDiory.propTypes = {
  diorys: _propTypes2.default.shape({
    startDate: _propTypes2.default.object,
    endDate: _propTypes2.default.object,
    images: _propTypes2.default.object,
    description: _propTypes2.default.object,
    places: _propTypes2.default.object,
    links: _propTypes2.default.object,
    persons: _propTypes2.default.object
  })
};

exports.default = EventDiory;